
#import "../libs/AppleTV.js"

// --------------------------------------------------------------------------------
//      Object: skynews
//              skynews is an ATVAApp object for interacting with the
//              Sky News appliance on Apple TV.
// --------------------------------------------------------------------------------

if (typeof skynews == 'undefined') {
    skynews = new ATVAApp("Sky News");
}

if (typeof skynews != 'undefined') {
    skynews._objectName = "skynews";

    // overriding fromMenu(), fromMenuAndHighlight(), goTo(), and goToAndHighlight() methods from base ATVAApp()

    skynews.appMenu = function appMenu() {
        if ( ! this._appMenu ) {
            this._appMenu = new ATVAPageStore(this._title);
        }
        return( this._appMenu );
    }

    skynews.fromMenu = function fromMenu() {
        if ( ! this.appMenu().waitForPage()) {
            UIALogger.logError(this._objectName + ".fromMenu(): failed to waiting for " + this._title);
            return(undefined);
        }
        return(this.appMenu());
    }

    skynews.fromMenuAndHighlight = function fromMenuAndHighlight(name) {
        var menu = this.fromMenu();
        if (menu) {
            if (menu.moveToTabWithName(name)) {
                // force delay because UI might hangup
                atvaTarget.delay(10);
                return(menu);
            }
            UIALogger.logError(this._objectName + ".fromMenuAndHighlight(): failed to move to " + name + " on " + this._title);
            return(undefined);
        }
        return(undefined);
    }

    skynews.fromMenuAndSelect = function fromMenuAndSelect(name) {
        var menu = this.fromMenuAndHighlight(name);
        if (menu) {
            menu.selectIntoPage();
            return(true);
        }
        UIALogger.logError(this._objectName + ".fromMenuAndSelect(): failed to select " + name + " on " + this._title);
        return(false);
    }

    skynews.goTo = function goTo() {
        if (ATVAPageMainMenu.goToAndSelect(this._title)) {
            return(this.fromMenu());
        }
        UIALogger.logError(this._objectName + ".goTo(): failed to get to " + this._title);
        return(undefined);
    }

    skynews.goToAndHighlight = function goToAndHighlight(name) {
        if ( ! this.goTo()) {
            return(undefined);
        }
        return(this.fromMenuAndHighlight(name));
    }

    skynews.goToAndSelect = function goToAndSelect(name) {
        if ( ! this.goTo()) {
            return(undefined);
        }
        return(this.fromMenuAndSelect(name));
    }
}
